import java.util.Scanner;

public class TCPClientTest {
    static Scanner scan = new Scanner(System.in);

    static final int BUFFER_SIZE = 512;
    byte[] sendData = new byte[BUFFER_SIZE];
    byte[] receiveData = new byte[BUFFER_SIZE];    
    TCPClient client = null;
    
    TCPClientTest(String ip, int port) {
        client = new TCPClient(ip, port);
    }
  
    public void send(String s) {
        if (client != null) {
	          Utility.paddingBytesArray(sendData, BUFFER_SIZE, s.getBytes(), s.length());
	          client.write(sendData, BUFFER_SIZE, true);	
        }
    }

    public String receive() {
    	String data = null;
        if (client != null) {
        	int nread = client.read(receiveData, BUFFER_SIZE, true);
	    	if (nread > 0) {
	    		data = Utility.getReceivedString(receiveData);
	    	}
	    }
        return data;
    }

    public static void main(String[] args) {
    	String ip = "127.0.0.1";
    	int port = 9000;
    	if (args.length >= 1) ip = args[0];
    	if (args.length >= 2) port = Integer.parseInt(args[1]);

        TCPClientTest t = new TCPClientTest(ip, port);
	    String text = "";
	    while (text.compareTo("bye") != 0) {
		    System.out.print("\t\tType your text: ");
		    text = scan.nextLine();
		    t.send(text);
		    String s = t.receive();
		    System.out.println("\t\tTCP CLIENT RECEIVED: " + s);
	    }
   	    System.out.println("TCP CLIENT: DONE");
    }
}
